var g_Battle_Ref;
/* Do not use 'this' with things in a menu, or
   branching off of a menu. Instead, use 'g_Battle_Ref.'
     eg. g_Battle_Ref.Enemies_Alive () would work. */   

// Base battle
function Battle ()
{
  g_Battle_Ref = this;
  this.Backdrop = undefined;     // The background of the Battle
  this.Grab_Image = new Array;   // To remember the menu's image from past use
  this.Include = function () {}  // To include things into the battle
  this.Run_Away = true;          // If you are allowed to run away from the battle
  this.Enemies = new Array;      // The Array you keep the enemies in
  this.Running = false;          // If the battle is running
  this.Turn_Array = new Array;   // Keeps record of all the turns  
  this.Cur_Player_Chosen_Index;  // Index of the current player (selected in menu) in the P_Array.
}

// Add an enemy to the battle
Battle.prototype.Add_Enemy = function (Which, posX, posY)
{
  var _num = this.Enemies.length;
  this.Enemies[_num] = Which.Clone ();  // Clone the enemy
  this.Enemies[_num].X = posX;          // X position on screen
  this.Enemies[_num].Y = posY;          // Y position on screen
}

// Execute the battle
Battle.prototype.Execute = function ()
{
  this.Running = true;                 // Set the battle to run

  // What you've encountered
  var _msg = "";
  for (var _num = 0; _num < this.Enemies.length; ++ _num)
  {
    if (_num !=  this.Enemies.length - 1) _msg += "a " + this.Enemies[_num].Name + ", ";
      else if (this.Enemies.length != 1) _msg += "and a " + this.Enemies[_num].Name;
        else _msg += "a " + this.Enemies[_num].Name;
  }     

  // Fade in monsters  
  for (var w = 0; w < this.Enemies.length; w ++)
  {
    for (var _num = 0; _num < 255; _num += 8)
    {
      while (AreKeysLeft ()) GetKey ();
      if (this.Backdrop != undefined) this.Backdrop.blit (0,0);
      System.window.drawWindow(10, 171, GetScreenWidth() - 20, 60);
      for (var a = 0; a < w; ++ a) this.Enemies[a].Image.blit (this.Enemies[a].X, this.Enemies[a].Y); 
      System.window.drawWindow(22, 20, GetScreenWidth () - 50, 25);
      System.font.drawTextBox(27, 20, GetScreenWidth () - 50, 25, 0, "You have encountered " + _msg + ".");
      this.Enemies[w].Image.blitMask (this.Enemies[w].X, this.Enemies[w].Y, CreateColor(255, 255, 255, _num));
      FlipScreen();
    }  
  }  
  while (GetKey () != System.accept);
  
  this.Engine ();
}

// Keep the Battle in a loop
Battle.prototype.Engine = function ()
{
  while (this.Running == true)
  {
    var _PAlive = Players_Alive();       // Remember how many players are alive
    var _EAlive = this.Enemies_Alive();  // Remember how many enemies are alive
  
    if (_EAlive <= 0)  // Check if all enemies are alive
    {
      this.Message ("You won!");
      this.Running = false;  
      this.Reset ();
    } 
    if (_PAlive <= 0)  // Check if all players are alive
    {
      this.Message ("Game over...");
      this.Running = false;
      this.Reset ();
      Abort ("You lost the game!");
    }
    this.Include ();    // Include other things into the battle.
    this.Draw ();       // Draw images
    this.Draw_Menu ();  // Draw menu
   
    // Turns
    if (this.Get_Selected_Players () == Players_Alive ())
    {
      
      this.Monster_Attack (); // Add the monster's attack to the Turn_Array.
    
      for (var i = 0; i < this.Turn_Array.length; i++)
      {
        // In case something happens, before attacking the next monster
        this.Include ();
        // Start the turn Array!
        this.Turn_Array[i] ();
      }
      
      // Reset the Selected players
      this.Reset_Selected_Players ();
      
      // Reset the turn array
      this.Turn_Array = new Array;
    }
  }
}

// Select a random player for the enemies to attack (temporary?)
Battle.prototype.Random_Player = function ()
{
  var which;
  
  while (which == undefined)
  {
    var a = Math.floor (Math.random() * 2);
    if (P_Array[a].HP > 0)
    {
      which = a;
    }
    else
    {
      // nothing
    }
  }
  
  return which;
}

// Add who the monsters attack in the Turn_Array 
Battle.prototype.Monster_Attack = function ()
{
  for (i = 0; i < this.Enemies.length; ++ i)
  {
    if (this.Enemies[i].HP > 0)
    {
      this.Turn_Array.push (new Function ("g_Battle_Ref.Attack (g_Battle_Ref.Enemies["+i+"], P_Array["+this.Random_Player()+"]);"));
    }
  }
}

// Check to see how many enemies are alive (if HP is over 0)
Battle.prototype.Enemies_Alive = function ()
{
  var _alive = 0;
  for (var _char = 0; _char < this.Enemies.length; ++ _char)
  {
    if (this.Enemies[_char].HP > 0)
    {
      _alive ++;
    }  
  } 
  return _alive;
}

// Check to see how many players are alive (if HP is over 0)
function Players_Alive ()
{
  var _alive = 0;
  for (var _char = 0; _char < P_Array.length; ++ _char)
  {
    if (P_Array[_char].HP > 0)
    {
      _alive ++;
    }
  }  
  return _alive;
}

// Check how many players have been selected for each turn
Battle.prototype.Get_Selected_Players = function ()
{
  var _selected = 0;
  for (var _char = 0; _char < P_Array.length; ++ _char)
  {
    if (P_Array[_char].HP > 0 && P_Array[_char].Selected == true)
    {
      _selected ++;
    }
  }
  return _selected;
}

// Reset the selected players
Battle.prototype.Reset_Selected_Players = function ()
{
  for (var _char = 0; _char < P_Array.length; ++ _char)
  {
    if (P_Array[_char].HP > 0)
    {
      P_Array[_char].Selected = false;
    }
  }
}

// Reset the battle
Battle.prototype.Reset = function ()
{
  // Reset HP and MP for the enemies
  for (var _num = 0; _num < this.Enemies.length; ++ _num)
  {
    this.Enemies[_num].HP = this.Enemies[_num].maxHP;
    this.Enemies[_num].MP = this.Enemies[_num].maxMP;
  }
}

// Draw the enemies and backdrop
Battle.prototype.Draw = function ()
{ 
  // Background
  if (this.Backdrop != undefined) this.Backdrop.blit (0,0);
  
  // Back window
  System.window.drawWindow(10, 171, GetScreenWidth() - 20, 60);
  
  // Enemies HP
  for (var _num = 0; _num < this.Enemies.length; ++ _num)
  {
    if (this.Enemies[_num].HP > 0)
    {
      this.Enemies[_num].Image.blit (this.Enemies[_num].X, this.Enemies[_num].Y);
      System.font.drawText (this.Enemies[_num].X - 2,
                            this.Enemies[_num].Y  + this.Enemies[_num].Image.height + 3, 
                            this.Enemies[_num].HP + " / " + this.Enemies[_num].maxHP);
    }
  }
}

// Messages in battle
Battle.prototype.Message = function (text)
{
  while (AreKeysLeft()){ GetKey(); }
  this.Draw ();
  System.window.drawWindow(22, 20, GetScreenWidth () - 50, 25);
  System.font.drawTextBox(27, 20, GetScreenWidth () - 50, 25, 0, text);
  FlipScreen ();
  while (GetKey () != System.accept);
}

// Draw the menu
Battle.prototype.Draw_Menu = function ()
{  
  if (this.Running == true)
  {
    g_Battle_Ref.Draw ();
    var menu = new Menu ();

    menu.addItem ("Fight",  new Function ("g_Battle_Ref.Player_Select ('Fight') ")); 
    menu.addItem ("Defend", new Function ("g_Battle_Ref.Player_Select ('Defend')"));
    menu.addItem ("Spells", new Function ("g_Battle_Ref.Player_Select ('Spells')"));
    menu.addItem ("Items",  new Function ("g_Battle_Ref.Player_Select ('Items') "));
    menu.addItem ("Run",    g_Battle_Ref.Run);
  
    menu.allow_escape = false;
    menu.render = function()
    {
      g_Battle_Ref.Include ();
      g_Battle_Ref.Grab_Image[0] = GrabImage(0, 0, GetScreenWidth(), GetScreenHeight())
    }
    menu.execute (10, 171, 70, 60);
  }
}

// Select player
Battle.prototype.Player_Select = function (type)
{
  g_Battle_Ref.Cur_Type = type;
  g_Battle_Ref.Draw ();
  g_Battle_Ref.Grab_Image[0].blit (0,0);
  
  var menu = new Menu ();
  var indexes = new Array;
  for (var _num = 0; _num < P_Array.length; ++ _num)
  {
    if (P_Array[_num].HP > 0 && P_Array[_num].Selected == false)
    {
      indexes.push (_num);
      switch (g_Battle_Ref.Cur_Type)
      {
        case ("Fight"):     
          menu.addItem (P_Array[_num].Name, new Function ("g_Battle_Ref.Cur_Player_Chosen_Index = " + _num + "; g_Battle_Ref.Enemy_Select (g_Battle_Ref.Cur_Type);"));
        break;
        case ("Defend"):
          menu.addItem (P_Array[_num].Name, new Function ("g_Battle_Ref.Message ('Defend not available!');"));
        break;
        case ("Spells"):
          menu.addItem (P_Array[_num].Name, new Function ("g_Battle_Ref.Message ('Spells not available!');"));
        break;
        case ("Items"):
          menu.addItem (P_Array[_num].Name, new Function ("g_Battle_Ref.Message ('Items not available!');"));
        break;
      }
    }
  }
  menu.allow_escape = true;
  menu.render = function ()
  {
    System.window.drawWindow (14, 14, 90, 25);
    GetSystemFont().drawText (14,14, "HP: " + P_Array[indexes[menu.selection]].HP + "/" + P_Array[indexes[menu.selection]].maxHP);
    GetSystemFont().drawText (14,25, "MP: " + P_Array[indexes[menu.selection]].MP + "/" + P_Array[indexes[menu.selection]].maxMP);
    g_Battle_Ref.Grab_Image[1] = GrabImage(0, 0, GetScreenWidth(), GetScreenHeight())
  }
  menu.execute (104, 171, 70, 60);
}

// Select enemy
Battle.prototype.Enemy_Select = function (type)
{
  g_Battle_Ref.Cur_Type = type;
  g_Battle_Ref.Draw ();
  g_Battle_Ref.Grab_Image[1].blit (0,0);
  
  var a;
  var menu = new Menu ();
  var indexes = new Array;
  for (var _num = 0; _num < g_Battle_Ref.Enemies.length; ++ _num)
  {
    if (g_Battle_Ref.Enemies[_num].HP > 0)
    {
      indexes.push (_num);
      menu.addItem (g_Battle_Ref.Enemies[_num].Name, new Function ("g_Battle_Ref.Turn_Array.push (new Function ('g_Battle_Ref.Attack ( P_Array[" + g_Battle_Ref.Cur_Player_Chosen_Index + "], g_Battle_Ref.Enemies["+_num+"]);')); P_Array[" + g_Battle_Ref.Cur_Player_Chosen_Index + "].Selected = true;"));
    }
  }
  for (var _num2 = 0; _num2 < P_Array.length; ++ _num2)
  {
    if (P_Array[_num2].HP > 0)
    {
      indexes.push (_num2);
      menu.addItem (P_Array[_num2].Name, new Function ("g_Battle_Ref.Turn_Array.push (new Function ('g_Battle_Ref.Attack (P_Array[" + g_Battle_Ref.Cur_Player_Chosen_Index + "], P_Array["+_num2+"]);')); P_Array[" + g_Battle_Ref.Cur_Player_Chosen_Index + "].Selected = true;"));
    } 
  }
  menu.allow_escape = true;
  menu.escape_function = function ()
  {
    g_Battle_Ref.Player_Select (g_Battle_Ref.Cur_Type);
  }
  menu.render = function ()
  {
    if (menu.selection < (g_Battle_Ref.Enemies.length - (g_Battle_Ref.Enemies.length - g_Battle_Ref.Enemies_Alive())))
    {
      if (g_Battle_Ref.Enemies[indexes[menu.selection]].HP > 0 && menu.selection < g_Battle_Ref.Enemies.length)
      {
        System.pointer.blit(g_Battle_Ref.Enemies[indexes[menu.selection]].X - 10, g_Battle_Ref.Enemies[indexes[menu.selection]].Y + 24);
      }
      System.window.drawWindow (14, 14, 90, 25);
      GetSystemFont().drawText (14,14, "HP: " + g_Battle_Ref.Enemies[indexes[menu.selection]].HP + "/" + g_Battle_Ref.Enemies[indexes[menu.selection]].maxHP);
      GetSystemFont().drawText (14,25, "MP: " + g_Battle_Ref.Enemies[indexes[menu.selection]].MP + "/" + g_Battle_Ref.Enemies[indexes[menu.selection]].maxMP);
    }
    else // If it's not an enemy, and actualy a player
    {
      System.window.drawWindow (14, 14, 90, 25);
      GetSystemFont().drawText (14,14, "HP: " + P_Array[indexes[menu.selection]].HP + "/" + P_Array[indexes[menu.selection]].maxHP);
      GetSystemFont().drawText (14,25, "MP: " + P_Array[indexes[menu.selection]].MP + "/" + P_Array[indexes[menu.selection]].maxMP);
    }
  }
  menu.execute (198, 171, 110, 60);
}

/* Damage prototype, calculates damage, then if the attack hits or not, if any of 
   the calculations dont make sense, blame squaresoft. (Added by NS) */
Battle.prototype.Attack = function (who, against_who) 
{  
  // Debug (who.Name + " is attacking " + against_who.Name + ".");

  // Make sure that the monsters health is above 0 along with the guy attacking
  if (who.HP > 0)
  {
    if (against_who.HP > 0)
    {
      // Multiplies the character's strength by 2
      var nStrength = who.Str * 2;  
  
      // Limit's the strength variable
      if (nStrength > 255) nStrength = 255;
      if (nStrength < 1)   nStrength = 1;   
  
      // Just gets the combined value of the players weapon attack, and strength, and multiplies 
      // it by 2.
      var nAttack = who.WAP + nStrength * 2; 
  
      // Calculates the damage by using above variables.
      var Damage = who.WAP + ((who.Lev * who.Lev * nAttack - against_who.Def) / 256) * 3 / 2; 
  
      // Limits the damage a bit
      if (Damage > 9999) Damage = 9999;
  
      // Randomizes the damage.
      Damage = Math.round((Damage * Math.floor(Math.random() * 255) / 256) + 1); 
  
      // The higher the character's Block stat is, the more likely they are to be hit.
      var nBlockValue = (255 - against_who.Blc * 2) + 1;
   
      // Required, keeps the above variable limited.
      if (nBlockValue > 255) nBlockValue = 255; 
      if (nBlockValue < 1)   nBlockValue = 1; 
  
      // Determines if the attack is a hit or not.
      var _player = false;
      for (var _b = 0; _b < P_Array.length; ++ _b) if (against_who == P_Array[_b]) _player = true;
      if ((who.Hit * nBlockValue) / 256 >= Math.floor(Math.random() * 99)) 
      {
        // Draw the hit
        if (_player == false)
        {  
          for (var _a = 5; _a < 20; _a += 0.1)
          {    
            this.Draw ();
            System.font.drawText (against_who.X + 10, against_who.Y - _a, Damage);
            FlipScreen();
          }
        }
        else
        {
          this.Message (who.Name + " does " + Damage + " damage to " + against_who.Name + "!");
        }
        against_who.HP -= Damage;
        if (against_who.HP < 0) against_who.HP = 0;
      }
      else 
      {
        // Draw the miss
        if (_player == false)
        {
          for (var _a = 5; _a < 20; _a += 0.6)
          {   
            this.Draw ();
            System.font.drawText (against_who.X + 9, against_who.Y - _a, "Miss");
            FlipScreen ();
          }
        }
        else
        {
          this.Message (who.Name + " misses " + against_who.Name + "!");
        }
      }
  
      // If the enemy has died, fade out
      if (against_who.HP <= 0)
      {
        if (_player == false)
        { 
          for (var i = 255; i > 1; i -= 20)
          {
            this.Draw ();
            against_who.Image.blitMask (against_who.X, against_who.Y, CreateColor(255, 255, 255, i))
            FlipScreen ();
          }
        }       
      }
    }
    else
    // If the health is below 0...
    {
      for (var i = 0; i < this.Enemies.length; i ++)
      {
        if (this.Enemies[i].HP > 0) 
        {
          against_who = this.Enemies[i];
          break;
        }
      } 
      if (this.Enemies_Alive() > 0) this.Attack (who, against_who);
    } 
  }
  else
  {
    // Debug ("Is dead.");
  }
}
// Run
Battle.prototype.Run = function ()
{
  if (g_Battle_Ref.Run_Away == true)
  {
    g_Battle_Ref.Message ("You run away.");
    g_Battle_Ref.Reset ();         // Reset the battle
    g_Battle_Ref.Running = false;  // Stop the battle running     
  }
  else
  {
    g_Battle_Ref.Message ("You cannot run away.");
  }
}

// Test battle! //////////////////////////////////
var Test_A = new Battle ();
Test_A.Add_Enemy (E_Array[0], 40,  75);   // Green Blob
Test_A.Add_Enemy (E_Array[1], 140, 55);   // Teddy
Test_A.Add_Enemy (E_Array[0], 240, 75);   // Green Blob
Test_A.v1 = false;  // Variable 1

Test_A.Include = function ()
{
  // Temporary test
  if (this.Enemies[0].HP <= 25 && this.v1 == false)
  {
    this.Message ("Blob: Ow, that hurts!");
    this.v1 = true;
  }
}
Test_A.Backdrop = LoadImage ("Bd1.png");
// ***********************************************

