// Base Enemy
function Enemy (Name, HP, MP)
{
  this.Name = Name; // Name 
  this.HP = HP;     // Health
  this.maxHP = HP;  // Maximum health
  this.MP = MP;     // Magic points
  this.maxMP = MP;  // Maximum magic points
  
  this.Str = 0;     // Strength
  this.Def = 0;     // Defence
  this.Agi = 0;     // Agility
  this.Mag = 0;     // Magic
  this.Blc = 0;     // Block Rate (Added by NS)
  
  this.Hit = 0;     // Hit Rate Percentage (Added by NS)
  this.WAP = 0;     // Weapon attack power (Added by NS)
  
  this.Lev = 0;     // Level
  
  this.Image = LoadImage (Name + ".png");  // Image
 } 

/* Clone the enemy, so that we don't accidently change
 the settings of the base enemy forever. */
Enemy.prototype.Clone = function ()
{
  var t = new Enemy (this.Name, this.HP, this.MP);
  
  t.Name  = this.Name;
  t.HP    = this.HP;
  t.maxHP = this.maxHP;
  t.MP    = this.MP;
  t.maxMP = this.maxMP;
  
  t.Str = this.Str;
  t.Def = this.Def;
  t.Agi = this.Agi;
  t.Mag = this.Mag;
  t.Blc = this.Blc;
  
  t.Lev = this.Lev;
  
  t.Hit = this.Hit; 
  t.WAP = this.WAP;
  
  t.X = this.X;
  t.Y = this.Y;
  
  return t;
}

// Create the enemies
var E_Array = new Array ();
E_Array[0] = new Enemy ("Green Blob", 50, 0);
E_Array[0].Str = 10;
E_Array[0].Def = 10;
E_Array[0].Agi = 6;
E_Array[0].Mag = 0;
E_Array[0].Lev = 1;
E_Array[0].Blc = 10;
E_Array[0].Hit = 255;
E_Array[0].WAP = 15;

E_Array[1] = new Enemy ("Teddy", 100, 50);
E_Array[1].Str = 16;
E_Array[1].Def = 12;
E_Array[1].Agi = 3;
E_Array[1].Mag = 0;
E_Array[1].Lev = 1;
E_Array[1].Blc = 10;
E_Array[1].Hit = 255;
E_Array[1].WAP = 20;