function Menu()
{
  while (AreKeysLeft()){ GetKey(); }
  if (this instanceof Menu == false) {
    return new Menu();
  }

  // default properties
  this.font = System.font;
  this.window_style = System.window;
  this.arrow = System.pointer;
  this.up_arrow = GetSystemUpArrow();
  this.down_arrow = GetSystemDownArrow();
  this.escape_function = function() { }
  this.allow_escape = true;
  this.select_menu = false;
  this.render = function() { }
  this.selection = 0;
  this.indexes = 0;
  this.items = new Array();
}

// add item
Menu.prototype.addItem = function(name, callback) {
  var item = new Object;
  item.name      = name;
  item.callback  = callback;
  this.items[this.items.length] = item;
}

// execute
Menu.prototype.execute = function(x, y, w, h) {
  with (this) {
    var background = GrabImage(0, 0, GetScreenWidth(), GetScreenHeight());   

    var text_height = font.getHeight();
    var shown_items = Math.floor(h / text_height);

    var selection = this.selection;
    var top_selection = 0;
    

    while (true) {
      var item = items[selection];
      // draw background
      background.blit(0, 0);

      // draw the window
      window_style.drawWindow(x, y, w, h);
      
      // draw the menu items
      for (var i = 0; i < shown_items; i++) {
        if (i < items.length) {
          font.drawText(x + 16 + 1, y + i * text_height, items[i + top_selection].name);
        }
      }   

      // draw the selection arrow
      arrow.blit(x, y + (selection - top_selection) * text_height);
           
      // draw the up and down arrows if necessary
      if (top_selection > 0) {
        up_arrow.blit(x + w - up_arrow.width, y);
      }
      if (top_selection + shown_items < items.length) {
        down_arrow.blit(x + w - down_arrow.width, y + text_height * shown_items - down_arrow.height);
        
     }

      // Render
      render();  

      FlipScreen();

      // handle keypresses
      while (AreKeysLeft()) {
        switch (GetKey()) {
          case KEY_CTRL: {              
            item.callback();
             return;
          }

          case KEY_ALT: {
           if (allow_escape == true)
           { 
             escape_function();
             return;
           }
           else
           {
             break;
           }
          }

          case KEY_DOWN: 
          {
            if (selection == items.length - 1) {
              selection = -1;
            }
            if (selection < items.length - 1) {
              selection++;          
              if (selection >= top_selection + shown_items) {
                top_selection++;
              }
            }
            break;
          }

          case KEY_UP: {
            if (selection == 0) {
              selection += items.length;
            }
            if (selection > 0) {
              selection --;              
              if (selection < top_selection) {
                top_selection--;
              }
            }
            break;
          } 

        }
      } // end handle input
    }

  } // end with
}